__gnu_parallel::_LoserTree< __stable, _Tp, _Compare > Class Template Reference
Inheritance diagram for __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >:
[legend]

## Public Member Functions

| _LoserTree (unsigned int __k, _Compare __comp)
void | __delete_min_insert (_Tp __key, bool __sup)
int | __get_min_source ()
void | __init ()
unsigned int | __init_winner (unsigned int __root)
void | __insert_start (const _Tp &__key, int __source, bool __sup)

## Protected Attributes

_Compare | _M_comp
bool | _M_first_insert
unsigned int | _M_ik
unsigned int | _M_k
unsigned int | _M_log_k
_Loser * | _M_losers
unsigned int | _M_offset

## Detailed Description

### template<bool __stable, typename _Tp, typename _Compare>
class __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >

Stable _LoserTree variant.

Provides the stable implementations of insert_start, __init_winner, __init and __delete_min_insert.

Unstable variant is done using partial specialisation below.

Definition at line 169 of file losertree.h.

## Member Function Documentation

template<bool __stable, typename _Tp , typename _Compare >

void __gnu_parallel::_LoserTree< __stable, _Tp, _Compare >::__delete_min_insert | ( | _Tp | __key,
|  | bool | __sup
| ) |  |

inline

Delete the smallest element and insert a new element from the previously smallest element's sequence.

This implementation is stable.

Definition at line 222 of file losertree.h.

References std::swap().

template<typename _Tp , typename _Compare >

int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__get_min_source | ( |  | ) |

inlineinherited

Returns
  the index of the sequence with the smallest element.

Definition at line 155 of file losertree.h.

References __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_losers, and __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_source.

template<typename _Tp , typename _Compare >

void __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__insert_start | ( | const _Tp & | __key,
|  | int | __source,
|  | bool | __sup
| ) |  |

inlineinherited

Initializes the sequence "_M_source" with the element "__key".

Parameters

  __key | the element to insert
  __source | __index of the __source __sequence
  __sup | flag that determines whether the value to insert is an explicit __supremum.

Definition at line 134 of file losertree.h.

References __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_first_insert, __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_key, __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_losers, __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_source, and __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_Loser::_M_sup.

## Member Data Documentation

template<typename _Tp , typename _Compare >

_Compare __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_comp

protectedinherited

_Compare to use.

Definition at line 78 of file losertree.h.

template<typename _Tp , typename _Compare >

bool __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_first_insert

protectedinherited

State flag that determines whether the _LoserTree is empty.

Only used for building the _LoserTree.

Definition at line 85 of file losertree.h.

Referenced by __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__insert_start(), and __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_LoserTreeBase().

template<typename _Tp , typename _Compare >

unsigned int __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_log_k

protectedinherited

log_2{_M_k}

Definition at line 72 of file losertree.h.

Referenced by __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_LoserTreeBase().

template<typename _Tp , typename _Compare >

_Loser* __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_M_losers

protectedinherited

_LoserTree __elements.

Definition at line 75 of file losertree.h.

Referenced by __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__get_min_source(), __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::__insert_start(), __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::_LoserTreeBase(), and __gnu_parallel::_LoserTreeBase< _Tp, _Compare >::~_LoserTreeBase().

The documentation for this class was generated from the following file:

- losertree.h